SystemOrganization addCategory: #GhostProxies!

!CompiledMethod methodsFor: '*GhostProxies' stamp: 'MarianoMartinezPeck 2/9/2012 11:42'!
ghostPrintString 
	^ self methodClass name asString ,  '>>', self selector! !

!Behavior methodsFor: '*GhostProxies' stamp: 'MarianoMartinezPeck 2/9/2012 10:34'!
methodDict
	methodDict == nil ifTrue: ["self manageMDFault" ^ self emptyMethodDictionary  ].
	^ methodDict! !

Object subclass: #GHGhostLogger
	instanceVariableNames: ''
	classVariableNames: 'ProxiesLoggerHolder'
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHGhostLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
changeToFileLogger
	"ProxiesLogger changeToFileLogger"
	^ self initialize! !

!GHGhostLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
changeToTranscriptLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: TranscriptLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
createAndSetLogger
	ProxiesLoggerHolder := self createLogger.! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
createLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: (FixesFileNameLoggerStrategy named: 'GhostLog.txt'). 
	logger startLogging.
	^ logger! !

!GHGhostLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
disableLogging
	| logger |
	logger := SimpleLogger new.
	logger strategy: NullLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!GHGhostLogger class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
example
	MyAppLogger logger mareaLog: 'zaraza'
	"Actually the idae is that you can create a method *MyAppLogger in Object that does:
	log: anObject
		MyAppLogger logger log: anObject
	
	So after, everywhere in your app you can just do self log: 'something'.
	"
	! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
initialize 
	ProxiesLoggerHolder := self createLogger.
	Smalltalk addToShutDownList: self.
	Smalltalk addToStartUpList: self.! !

!GHGhostLogger class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
logger
	ProxiesLoggerHolder
		ifNil: [ProxiesLoggerHolder := self createLogger].
	^ ProxiesLoggerHolder! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
reopenStreamIfExists
	self logger reopenStreamIfClosed! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
shutDown
! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
startUp
	self reopenStreamIfExists! !

!GHGhostLogger methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
seeClassSide ! !

Object subclass: #GHInstanceOfProxifiedClassInterceptionDelegator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHInstanceOfProxifiedClassInterceptionDelegator methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 14:40'!
cannotInterpret: aMessage 
	| interception context  counter|
	self log:  'cannotInterpret:  ', aMessage selector.
	self log:  'Stack:  '.
	self log:  '----------------'.
		
	context := thisContext sender.
	counter := 0.
	[context isNil not and: [counter < 50]] whileTrue:  [
		self log: context  method ghostPrintString.
		context := context sender.
		counter := counter + 1.
		].

	^ aMessage lookupClass handleInterceptionToInstance: aMessage andReceiver: self
	
! !

Object subclass: #GHInterception
	instanceVariableNames: 'message proxy receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHInterception class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 10:31'!
for: aMessage proxy: aProxy
	^ self new initializeWith: aMessage proxy: aProxy receiver: nil. ! !

!GHInterception methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 10:32'!
initializeWith: aMessage proxy: aProxy receiver: aReceiver
	message := aMessage.
	proxy := aProxy.
	receiver := aReceiver.! !

!GHInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 10:55'!
message
	^ message! !

!GHInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 10:55'!
proxy
	^ proxy! !

!GHInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 10:55'!
receiver
	^ receiver! !

Object subclass: #GHInterceptionDelegator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHInterceptionDelegator methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:42'!
cannotInterpret: aMessage 
	| interception context  counter|
	self log:  'cannotInterpret:  ', aMessage selector.
	self log:  'Stack:  '.
	self log:  '----------------'.
		
	context := thisContext sender.
	counter := 0.
	[context isNil not and: [counter < 50]] whileTrue:  [
		self log: context  method ghostPrintString.
		context := context sender.
		counter := counter + 1.
		].
		
	interception := GHInterception for: aMessage proxy: self. 
	^ self proxyHandler handleInterception: interception.! !

GHInterceptionDelegator subclass: #GHProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

GHProxyTrap subclass: #GHAbstractProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

GHAbstractProxy subclass: #GHAbstractClassProxy
	instanceVariableNames: 'superclass methodDict format'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHAbstractClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 14:24'!
initializeClassProxy
	superclass := GHInstanceOfProxifiedClassInterceptionDelegator.
	methodDict := nil.
	format := GHAbstractClassProxy format.! !

GHAbstractClassProxy subclass: #GHClassProxy
	instanceVariableNames: 'handler target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHClassProxy class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 14:23'!
createProxyAndReplace: anObjectThenProxy handler: aHandler
   | aProxyThenObject |
	"It is important to use basicNew because otherwise we are forced to implement #initialize"
       aProxyThenObject := self basicNew
		initializeWith: anObjectThenProxy
		handler: aHandler. 
		"I cannot send #become because it will be intercepted by the proxy"	
	(Array with: aProxyThenObject)
		elementsExchangeIdentityWith:
			(Array with: anObjectThenProxy).
        "After the become is done, aProxyThenObject now points
	 to the original object, and  anObjectThenProxy points to 
	the proxy"
       anObjectThenProxy proxyTarget: aProxyThenObject.
	GHProxyTrap initialize.
       ^ anObjectThenProxy.
! !

!GHClassProxy class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 14:22'!
createProxyFor: anObject handler: aHandler
	| aProxy |
	"It is important to use basicNew because otherwise we are forced to implement #initialize"
    	aProxy:= self basicNew
		initializeWith: anObject
		handler: aHandler. 
       GHProxyTrap initialize.
       ^ aProxy.
! !

!GHClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 14:24'!
initializeWith: aTarget handler: aHandler
	self initializeClassProxy.
	target := aTarget.
	handler := aHandler.
	! !

!GHClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 14:25'!
proxyHandler
	^ handler! !

!GHClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 14:25'!
proxyTarget
	^ target! !

!GHClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 14:25'!
proxyTarget: anObject
	target := anObject! !

!GHAbstractProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:44'!
class
	"We just need it for debugging purposes"
	
	<primitive: 111>
	self primitiveFailed! !

!GHAbstractProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:39'!
log: aString
	GHGhostLogger logger log: aString.! !

!GHAbstractProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:40'!
proxyHandler! !

GHAbstractProxy subclass: #GHProxy
	instanceVariableNames: 'handler target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHProxy class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:54'!
createProxyAndReplace: anObjectThenProxy handler: aHandler
   | aProxyThenObject |
	"It is important to use basicNew because otherwise we are forced to implement #initialize"
       aProxyThenObject := self basicNew
		initializeWith: anObjectThenProxy
		handler: aHandler. 
		"I cannot send #become because it will be intercepted by the proxy"	
	(Array with: aProxyThenObject)
		elementsExchangeIdentityWith:
			(Array with: anObjectThenProxy).
        "After the become is done, aProxyThenObject now points
	 to the original object, and  anObjectThenProxy points to 
	the proxy"
       anObjectThenProxy proxyTarget: aProxyThenObject.
	GHProxyTrap initialize.
       ^ anObjectThenProxy.
! !

!GHProxy class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:51'!
createProxyFor: anObject handler: aHandler
	| aProxy |
	"It is important to use basicNew because otherwise we are forced to implement #initialize"
    	aProxy:= self basicNew
		initializeWith: anObject
		handler: aHandler. 
       GHProxyTrap initialize.
       ^ aProxy.
! !

!GHProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 10:42'!
initializeWith: aTarget handler: aHandler
	target := aTarget.
	handler := aHandler! !

!GHProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:23'!
proxyHandler
	^ handler! !

!GHProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 10:57'!
proxyTarget
	^ target! !

!GHProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 10:43'!
proxyTarget: aTarget
	target := aTarget! !

!GHProxyTrap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 10:35'!
initialize
	self nilMethodDict ! !

!GHProxyTrap class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 10:35'!
nilMethodDict
	methodDict := nil. ! !

Object subclass: #GHProxyHandler
	instanceVariableNames: 'methodsNotToIntercept'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 14:41'!
classProxyMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #handleInterceptionToInstance:andReceiver:  put: #handleInterceptionToInstanceFor:.
	^ dict
! !

!GHProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 14:58'!
defaultMethodsNotToIntercept
	| dict |
	dict := Dictionary new.
	dict addAll: self methodsMessagesToHandle.
	"dict addAll: self debuggingMessagesToHandle."
	dict addAll: self testSupportMessagesToHandle.
	dict addAll: self classProxyMessagesToHandle.
	^ dict
	
	! !

!GHProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 12:10'!
handleInterception: anInterception
	self log:  'message ', anInterception message selector, ' intercepted'.
	
	(self isMessageNotToIntercept: anInterception message)
		ifTrue: [ ^ self manageMessageInternally: anInterception  ]
	 	ifFalse: [ ^ self manageMessage: anInterception  ]
	! !

!GHProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 12:10'!
isMessageNotToIntercept: aMessage
	^ self methodsNotToIntercept includesKey: aMessage selector  ! !

!GHProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 12:10'!
manageMessageInternally: anInterception 
	self log: 'The method ', anInterception message selector, ' will NOT be forwarded by instead answer by the handler'.
	^ self perform: (self methodsNotToIntercept at: anInterception message selector) with: anInterception ! !

!GHProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:46'!
methodsMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #flushCache put: #handleFlushCache:.
	dict at: #run:with:in: put: #handleMethodExecution:.
	^ dict
! !

!GHProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:45'!
methodsNotToIntercept
	methodsNotToIntercept isNil ifTrue: [ methodsNotToIntercept := self defaultMethodsNotToIntercept ].
	^ methodsNotToIntercept ! !

!GHProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 14:58'!
testSupportMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #uninstall put: #handleUninstall:.
	^ dict 
	! !

GHProxyHandler subclass: #GHSimpleForwarderProxyHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHSimpleForwarderProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:47'!
handleFlushCache: anInterception
	^ anInterception proxy proxyTarget selector flushCache	 
		! !

!GHSimpleForwarderProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 14:47'!
handleInterceptionToInstanceFor: anInterception
	| message targetClass receiver |
	message := anInterception message arguments first.
	targetClass := anInterception proxy proxyTarget.
	receiver := anInterception message arguments second.
	self log: 'message ', message selector, ' to instance intercepted and will be forwarded'.
	^ CompiledMethod receiver: receiver withArgs: message arguments  executeMethod:  (targetClass lookupSelector: message selector) 
	! !

!GHSimpleForwarderProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:47'!
handleMethodExecution: anInterception
	self log: 'message ', anInterception message selector, ' execution intercepted and will be forwarded'.
	^ anInterception proxy proxyTarget valueWithReceiver: anInterception message arguments third arguments: anInterception message arguments second
	
! !

!GHSimpleForwarderProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 14:59'!
handleUninstall: anInterception

	self log: 'message ', anInterception message selector, ' received and the proxy will be uninstalled'.
	^ anInterception proxy proxyTarget become: anInterception proxy.
	! !

!GHSimpleForwarderProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:14'!
log: aString
	GHGhostLogger logger log: aString.! !

!GHSimpleForwarderProxyHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 10:57'!
manageMessage: interception
	self log: 'The method ', interception message selector, ' will beforwarded'.
	^ interception message sendTo: interception proxy proxyTarget! !
GHGhostLogger initialize!
GHProxyTrap initialize!
